// Megoldás:
// https://forum.lazarus.freepascal.org/index.php/topic,50888.msg372481.html#msg372481


unit QRide;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  ubarcodes  ,  fpvectorial, wmfvectorialwriter;

type

  { TForm1 }

  TForm1 = class(TForm)
    QQ: TBarcodeQR;
    btn_GEN: TButton;
    ed_Long: TEdit;
    ed_Lati: TEdit;
    im: TImage;
    procedure btn_GENClick(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.frm}

uses
  FPImage, fpimgcanv , zint, lbc_render;

type
  TMyLazBarcode = class(TLazBarcodeCustomBase);
  TDoubleRect   = record Left, Top, Right, Bottom: Double; end;



function DoubleRect(X1, Y1, X2, Y2: Double): TDoubleRect;
begin
  Result.Left   := X1;
  Result.Top    := Y1;
  Result.Right  := X2;
  Result.Bottom := Y2;
end;



procedure BarcodeToFPVectorial(ABarCode: TLazBarcodeCustomBase;
  APage: TvVectorialPage; out ErrorMsg: String);
var
  R        : TDoubleRect;
  barcode  : TMyLazBarCode;
  qr       : PointerTo_zint_symbol;
  ErrorCode: integer;
  Line     : PointerTo_zint_render_line;
  BaseX,
  BaseY    : integer;
  X, Y     : integer;

  function InvertY(AY: Double): Double; inline;
  begin
    with R do
      Result := Bottom - Top - AY;
  end;

  procedure FillRect(X1, Y1, X2, Y2: Double);
  begin
    APage.StartPath    (X1, InvertY(Y1));
    APage.AddLineToPath(X1, InvertY(Y2));
    APage.AddLineToPath(X2, InvertY(Y2));
    APage.AddLineToPath(X2, InvertY(Y1));
    APage.AddLineToPath(X1, InvertY(Y1));
    APage.SetBrushColor(colBlack);
    APage.SetBrushStyle(bsSolid);
    APage.SetPenStyle  (psClear);
    APage.EndPath();
  end;

begin
  barcode := TMyLazBarCode(ABarCode);
  qr      := barcode.FQR;
  if not Assigned(qr^.rendered) then begin
    qr^.border_width := 0;       // remove white border
    R := DoubleRect(0, 0, APage.Width, APage.Height);
    X := round(R.Right - R.Left) + 1;
    Y := round(R.Bottom - R.Top) + 1;
    if not barcode.FStrictSize then begin
      ErrorCode := render_plot(qr, X, Y);
    end else begin
      BaseX     := qr^.width;// + qr^.border_width*2;
      BaseY     := qr^.rows ;// + qr^.border_width*2;
      ErrorCode := render_plot(qr, X - (X mod BaseX), (Y - (Y mod BaseY)));
    end;
    if ErrorCode <> 1 then begin
      ErrorMsg := qr^.errtxt;
      exit;
    end else begin
      ErrorMsg := '';
    end;
  end;

  if Assigned(qr^.rendered) then
  begin
    Line := qr^.rendered^.lines;
    APage.Clear;
    while Assigned(Line) do begin
      FillRect(
        Line^.x + R.Left,
        Line^.y + R.Top,
        Line^.x + R.Left + Line^.width,
        Line^.y + R.Top  + Line^.length
      );
      Line := Line^.next;
    end;
  end;
end;





{ TForm1 }

procedure TForm1.btn_GENClick(Sender: TObject);
var
   vQQ  : TBarcodeQR;
   R    : TRect;
   vec  : TvVectorialDocument;
   page : TvVectorialPage;
   errorMsg : string;
   min      : Longint;

// CV       : TFPCustomCanvas;
   (*
   BmI: TFPMemoryImage;
   BmC: TFPImageCanvas;
   BmW: TFPWriterBMP;

//   vvec:  TvVectorialDocument;
   bmp: TBitmap;
   fs : TFileStream;     *)
begin
//QQ.ECCLevel:= ;
    R := Rect( 0, 0, 256, 256);
    vQQ := TBarcodeQR.Create(nil);
    vQQ.Height:= R.Height;
    vQQ.Width := R.Width;
    vQQ.Text:= 'geo:44.140315,-73.746625';
    vQQ.Generate;

    vec := TvVectorialDocument.Create;

    try
      vec.Width  := 256;   // mm
      vec.Height := 256;
      Page := Vec.AddPage();
            min := Page.RenderInfo.EntityCanvasMinXY.X;
            Self.Caption := 'Min=' + IntToStr(min);

      BarcodeToFPVectorial(vQQ, page, errorMsg);
//    vec.ZoomLevel := 1.5;
//    Page.AutoFit( CV, );
//     RegisterVectorialWriter( vfWindowsMetafileWMF );
      vec.WritetoFile('barcode.wmf', vfWindowsMetafileWMF);
    finally
      vec.Free;
    end;


    vQQ.free;

    (*
    try
      bmi := TFPMemoryImage.Create(R.Width, R.Height);
      bmi.UsePalette   := True;
      bmi.Palette.Color[0] := FPColor($FFFF, $FFFF, $FFFF); // white
      bmi.Palette.Color[1] := FPColor($0000, $0000, $0000); // black

      BmC := TFPImageCanvas.Create(BmI);

//      vQQ.PaintOnCanvas(BmC, R);

      bmW := TFPWriterBMP.Create();
      bmW.BitsPerPixel := 1;

      im.Picture.Assign( bmi );
      bmi.SaveToFile('C:\bbimg.bmp', BmW);
exit;

      //      bmp.BeginUpdate();
      bmp := TBitmap.Create;
      bmp.Monochrome:= true;
      bmp.SetSize(R.Width, R.Height);
      bmp.Monochrome         := True;
      bmp.PixelFormat        := pf1bit;
      bmp.Transparent        := False;
      bmp.Masked             := False;
      bmp.Canvas.Brush.Color := clWhite;
      bmp.Canvas.FillRect(R);
      vQQ.PaintOnCanvas(bmp.Canvas, R);
      fs := TFileStream.Create('c:\imFS.bmp', fmCreate );       //and fmOpenReadWrite
      try
         fs.GoToStart;
         bmp.SaveToStream(fs);
         fs.GoToStart;
      finally
        fs.Free;
      end;
      //      bmp.EndUpdate(False);

    // im.Picture.Assign( bmp );
    // im.Picture.SaveToFile('C:\bbimg.bmp');

    //      bmp.SaveToFile('C:\barcode.bmp');


    finally
      bmp.Free;
      bmi.Free;
    end;
    *)

end;

end.

